package gregapi.block.behaviors;

import gregapi.block.prefixblock.PrefixBlock;
import gregapi.code.ArrayListNoNulls;
import gregapi.data.OP;
import gregapi.oredict.OreDictMaterial;
import gregapi.util.UT;

import java.util.ArrayList;
import java.util.Random;

import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

public class Drops_SmallOre extends Drops {
	private final OreDictMaterial mSecondaryDrop;
	
	public Drops_SmallOre(OreDictMaterial aSecondaryDrop) {
		super((Item)null);
		mSecondaryDrop = aSecondaryDrop;
	}
	
	@Override
	public ArrayList<ItemStack> getDrops(PrefixBlock aBlock, World aWorld, int aX, int aY, int aZ, short aMetaData, TileEntity aTileEntity, int aFortune, boolean aSilkTouch) {
		ArrayList<ItemStack> rList = new ArrayListNoNulls<ItemStack>();
	    OreDictMaterial aMaterial = aBlock.getMetaMaterial(aMetaData);
        
		if (aMaterial != null) {
			Random tRandom = new Random(aX ^ aY ^ aZ);
			ArrayList<ItemStack> tSelector = new ArrayListNoNulls<ItemStack>();
			ItemStack
			
			tStack = OP.gemExquisite.mat(aMaterial, OP.gem.mat(aMaterial, 1), 1);
			if (tStack != null) for (byte i = 0; i < (aSilkTouch? 3: 1); i++) tSelector.add(tStack);
			tStack = OP.gemFlawless.mat(aMaterial, OP.gem.mat(aMaterial, 1), 1);
			if (tStack != null) for (byte i = 0; i < (aSilkTouch? 6: 2); i++) tSelector.add(tStack);
			tStack = OP.gem.mat(aMaterial, 1);
			if (tStack != null) for (byte i = 0; i < (aSilkTouch? 6:12); i++) tSelector.add(tStack);
			
			tStack = OP.gemFlawed.mat(aMaterial, OP.crushed.mat(aMaterial, 1), 1);
			if (tStack != null) for (byte i = 0; i < (aSilkTouch?10: 5); i++) tSelector.add(tStack);
			tStack = OP.crushed.mat(aMaterial, 1);
			if (tStack != null) for (byte i = 0; i < (aSilkTouch? 5:10); i++) tSelector.add(tStack);
			
			tStack = OP.gemChipped.mat(aMaterial, OP.dustImpure.mat(aMaterial, 1), 1);
			if (tStack != null) for (byte i = 0; i < (aSilkTouch?10: 5); i++) tSelector.add(tStack);
			tStack = OP.dustImpure.mat(aMaterial, OP.dust.mat(aMaterial, 1), 1);
			if (tStack != null) for (byte i = 0; i < (aSilkTouch? 5:10); i++) tSelector.add(tStack);
			
			if (tSelector.size() > 0) {
				for (int i = 0, j = Math.max(1, aMaterial.mOreMultiplier+(aFortune>0?(tRandom.nextInt((1+aFortune)*aMaterial.mOreMultiplier)):0)/2); i < j; i++) {
					rList.add(UT.Stacks.amount(1, tSelector.get(tRandom.nextInt(tSelector.size()))));
				}
			}
			
			if (mSecondaryDrop != null && tRandom.nextInt(3+aFortune)>1) rList.add((tRandom.nextInt(3)>0?OP.dustImpure:OP.dust).mat(mSecondaryDrop.mTargetCrushing.mMaterial, 1));
		}
		return rList;
    }
}