package gregapi.old;

import static gregapi.data.CS.DYES;
import static gregapi.data.CS.RES_PATH_BLOCK;
import static gregapi.data.CS.RES_PATH_ITEM;
import static gregapi.data.CS.UNCOLOURED;
import gregapi.GT_API;
import gregapi.render.BlockTextureDefault;
import gregapi.render.IIconContainer;
import gregapi.render.ITexture;
import gregapi.util.UT;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.util.IIcon;
import net.minecraft.util.ResourceLocation;

public class Textures {
	public enum BlockIcons implements IIconContainer, Runnable {
		  VOID, RENDERING_ERROR
		, PIPE_RESTRICTOR, INSULATION_FULL, INSULATION_TINY, INSULATION_SMALL, INSULATION_MEDIUM, INSULATION_LARGE, INSULATION_HUGE
		, CFOAM_FRESH, CFOAM_HARDENED, GLASS_CLEAR, CRATE, COIN, COIN_SIDE, COIN_TOP, COIN_BOTTOM
		
		, CONCRETE_LIGHT_STONE	, CONCRETE_LIGHT_COBBLE	, CONCRETE_LIGHT_COBBLE_MOSSY	, CONCRETE_LIGHT_BRICKS	, CONCRETE_LIGHT_BRICKS_CRACKED	, CONCRETE_LIGHT_BRICKS_MOSSY	, CONCRETE_LIGHT_BRICKS_CHISELED	, CONCRETE_LIGHT_SMOOTH	, CONCRETE_LIGHT_BRICKS_REINFORCED
		, CONCRETE_DARK_STONE	, CONCRETE_DARK_COBBLE	, CONCRETE_DARK_COBBLE_MOSSY	, CONCRETE_DARK_BRICKS	, CONCRETE_DARK_BRICKS_CRACKED	, CONCRETE_DARK_BRICKS_MOSSY	, CONCRETE_DARK_BRICKS_CHISELED		, CONCRETE_DARK_SMOOTH	, CONCRETE_DARK_BRICKS_REINFORCED
		, GRANITE_BLACK_STONE	, GRANITE_BLACK_COBBLE	, GRANITE_BLACK_COBBLE_MOSSY	, GRANITE_BLACK_BRICKS	, GRANITE_BLACK_BRICKS_CRACKED	, GRANITE_BLACK_BRICKS_MOSSY	, GRANITE_BLACK_BRICKS_CHISELED		, GRANITE_BLACK_SMOOTH	, GRANITE_BLACK_BRICKS_REINFORCED
		, GRANITE_RED_STONE		, GRANITE_RED_COBBLE	, GRANITE_RED_COBBLE_MOSSY		, GRANITE_RED_BRICKS	, GRANITE_RED_BRICKS_CRACKED	, GRANITE_RED_BRICKS_MOSSY		, GRANITE_RED_BRICKS_CHISELED		, GRANITE_RED_SMOOTH	, GRANITE_RED_BRICKS_REINFORCED
		, MARBLE_STONE			, MARBLE_COBBLE			, MARBLE_COBBLE_MOSSY			, MARBLE_BRICKS			, MARBLE_BRICKS_CRACKED			, MARBLE_BRICKS_MOSSY			, MARBLE_BRICKS_CHISELED			, MARBLE_SMOOTH			, MARBLE_BRICKS_REINFORCED
		, BASALT_STONE			, BASALT_COBBLE			, BASALT_COBBLE_MOSSY			, BASALT_BRICKS			, BASALT_BRICKS_CRACKED			, BASALT_BRICKS_MOSSY			, BASALT_BRICKS_CHISELED			, BASALT_SMOOTH			, BASALT_BRICKS_REINFORCED
		;
		
		protected IIcon mIcon;
		
		@Override public IIcon getIcon(int aRenderPass) {return mIcon;}
		
		private BlockIcons() {
			GT_API.sBlockIconload.add(this);
		}
		
		@Override
		public void run() {
			mIcon = GT_API.sBlockIcons.registerIcon(RES_PATH_BLOCK + "iconsets/" + this);
		}
		
		@Override
		public ResourceLocation getTextureFile() {
			return TextureMap.locationBlocksTexture;
		}
		
		/**
		 * Icon for Fresh CFoam
		 */
	    public static final ITexture[] FRESHFOAM = new ITexture[] {new BlockTextureDefault(CFOAM_FRESH)};
	    
	    /**
	     * Icons for Hardened CFoam
	     * 0 = No Color
	     * 1 - 16 = Colors
	     */
	    public static final ITexture[][] HARDENEDFOAMS = new ITexture[][] {
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, UT.Code.getRGBInt(64, 64, 64))},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 0])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 1])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 2])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 3])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 4])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 5])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 6])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 7])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 8])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[ 9])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[10])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[11])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[12])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[13])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[14])},
	    	new ITexture[] {new BlockTextureDefault(CFOAM_HARDENED, DYES[15])}
	    };
	    
	    public static final IIconContainer[]
	    CFOAMS = new IIconContainer[] {
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
	    	CFOAM_HARDENED,
		},
	    CFOAMS_FRESH = new IIconContainer[] {
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		    CFOAM_FRESH,
		},
	    GLASSES_CLEAR = new IIconContainer[] {
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		    GLASS_CLEAR,
		},
	    MARBLES = new IIconContainer[] {
	    	MARBLE_STONE,
	    	MARBLE_COBBLE,
	    	MARBLE_COBBLE_MOSSY,
	    	MARBLE_BRICKS,
	    	MARBLE_BRICKS_CRACKED,
	    	MARBLE_BRICKS_MOSSY,
	    	MARBLE_BRICKS_CHISELED,
	    	MARBLE_SMOOTH,
	    	MARBLE_BRICKS_REINFORCED,
	    	MARBLE_COBBLE,
	    	MARBLE_COBBLE_MOSSY,
	    	MARBLE_BRICKS,
	    	MARBLE_BRICKS_CRACKED,
	    	MARBLE_BRICKS_MOSSY,
	    	MARBLE_BRICKS_CHISELED,
	    	MARBLE_SMOOTH,
	    },
	    BASALTS = new IIconContainer[] {
	    	BASALT_STONE,
	    	BASALT_COBBLE,
	    	BASALT_COBBLE_MOSSY,
	    	BASALT_BRICKS,
	    	BASALT_BRICKS_CRACKED,
	    	BASALT_BRICKS_MOSSY,
	    	BASALT_BRICKS_CHISELED,
	    	BASALT_SMOOTH,
	    	BASALT_BRICKS_REINFORCED,
	    	BASALT_COBBLE,
	    	BASALT_COBBLE_MOSSY,
	    	BASALT_BRICKS,
	    	BASALT_BRICKS_CRACKED,
	    	BASALT_BRICKS_MOSSY,
	    	BASALT_BRICKS_CHISELED,
	    	BASALT_SMOOTH,
	    },
	    GRANITES_BLACK = new IIconContainer[] {
	    	GRANITE_BLACK_STONE,
	    	GRANITE_BLACK_COBBLE,
	    	GRANITE_BLACK_COBBLE_MOSSY,
	    	GRANITE_BLACK_BRICKS,
	    	GRANITE_BLACK_BRICKS_CRACKED,
	    	GRANITE_BLACK_BRICKS_MOSSY,
	    	GRANITE_BLACK_BRICKS_CHISELED,
	    	GRANITE_BLACK_SMOOTH,
	    	GRANITE_BLACK_BRICKS_REINFORCED,
	    	GRANITE_BLACK_COBBLE,
	    	GRANITE_BLACK_COBBLE_MOSSY,
	    	GRANITE_BLACK_BRICKS,
	    	GRANITE_BLACK_BRICKS_CRACKED,
	    	GRANITE_BLACK_BRICKS_MOSSY,
	    	GRANITE_BLACK_BRICKS_CHISELED,
	    	GRANITE_BLACK_SMOOTH,
	    },
	    GRANITES_RED = new IIconContainer[] {
			GRANITE_RED_STONE,
			GRANITE_RED_COBBLE,
			GRANITE_RED_COBBLE_MOSSY,
			GRANITE_RED_BRICKS,
			GRANITE_RED_BRICKS_CRACKED,
			GRANITE_RED_BRICKS_MOSSY,
			GRANITE_RED_BRICKS_CHISELED,
			GRANITE_RED_SMOOTH,
			GRANITE_RED_BRICKS_REINFORCED,
			GRANITE_RED_COBBLE,
			GRANITE_RED_COBBLE_MOSSY,
			GRANITE_RED_BRICKS,
			GRANITE_RED_BRICKS_CRACKED,
			GRANITE_RED_BRICKS_MOSSY,
			GRANITE_RED_BRICKS_CHISELED,
			GRANITE_RED_SMOOTH,
		},
	    CONCRETES_LIGHT = new IIconContainer[] {
			CONCRETE_LIGHT_STONE,
			CONCRETE_LIGHT_COBBLE,
			CONCRETE_LIGHT_COBBLE_MOSSY,
			CONCRETE_LIGHT_BRICKS,
			CONCRETE_LIGHT_BRICKS_CRACKED,
			CONCRETE_LIGHT_BRICKS_MOSSY,
			CONCRETE_LIGHT_BRICKS_CHISELED,
			CONCRETE_LIGHT_SMOOTH,
			CONCRETE_LIGHT_BRICKS_REINFORCED,
			CONCRETE_LIGHT_COBBLE,
			CONCRETE_LIGHT_COBBLE_MOSSY,
			CONCRETE_LIGHT_BRICKS,
			CONCRETE_LIGHT_BRICKS_CRACKED,
			CONCRETE_LIGHT_BRICKS_MOSSY,
			CONCRETE_LIGHT_BRICKS_CHISELED,
			CONCRETE_LIGHT_SMOOTH,
		},
		CONCRETES_DARK = new IIconContainer[] {
			CONCRETE_DARK_STONE,
			CONCRETE_DARK_COBBLE,
			CONCRETE_DARK_COBBLE_MOSSY,
			CONCRETE_DARK_BRICKS,
			CONCRETE_DARK_BRICKS_CRACKED,
			CONCRETE_DARK_BRICKS_MOSSY,
			CONCRETE_DARK_BRICKS_CHISELED,
			CONCRETE_DARK_SMOOTH,
			CONCRETE_DARK_BRICKS_REINFORCED,
			CONCRETE_DARK_COBBLE,
			CONCRETE_DARK_COBBLE_MOSSY,
			CONCRETE_DARK_BRICKS,
			CONCRETE_DARK_BRICKS_CRACKED,
			CONCRETE_DARK_BRICKS_MOSSY,
			CONCRETE_DARK_BRICKS_CHISELED,
			CONCRETE_DARK_SMOOTH,
		};
	    
		public static class CustomIcon implements IIconContainer, Runnable {
			protected IIcon mIcon;
			protected String mIconName;
			
			@Override public IIcon getIcon(int aRenderPass) {return mIcon;}
			
			public CustomIcon(String aIconName) {
				mIconName = aIconName;
				GT_API.sBlockIconload.add(this);
			}
			
			@Override
			public void run() {
				mIcon = GT_API.sBlockIcons.registerIcon(RES_PATH_BLOCK + mIconName);
			}
			
			@Override
			public ResourceLocation getTextureFile() {
				return TextureMap.locationBlocksTexture;
			}
			
			@Override
			public short[] getIconColor(int aRenderPass) {
				return UNCOLOURED;
			}
			
			@Override
			public int getIconPasses() {
				return 1;
			}
			
			@Override
			public void registerIcons(IIconRegister aIconRegister) {
				//
			}
			
			@Override
			public boolean isUsingColorModulation(int aRenderPass) {
				return aRenderPass == 0;
			}
		}

		@Override
		public short[] getIconColor(int aRenderPass) {
			return UNCOLOURED;
		}

		@Override
		public int getIconPasses() {
			return 1;
		}

		@Override
		public void registerIcons(IIconRegister aIconRegister) {
			//
		}

		@Override
		public boolean isUsingColorModulation(int aRenderPass) {
			// TODO Auto-generated method stub
			return aRenderPass == 0;
		}
	}
	
	public enum ItemIcons implements IIconContainer, Runnable {
		  VOID // The Empty Texture
		, RENDERING_ERROR
		, WRENCH, MONKEYWRENCH
		, MORTAR
		, CROWBAR
		, JACKHAMMER
		, WIRE_CUTTER
		, FLINT_TINDER
		, BENDING_CYLINDER, BENDING_CYLINDER_SMALL, PINCERS
		, KNIFE, BUTCHERYKNIFE, SICKLE
		, SCOOP, GRAFTER, SCISSORS
		, PLUNGER, ROLLING_PIN, MAGNIFYING_GLASS
		, HANDLE_SWORD, HANDLE_FILE, HANDLE_CHISEL, HANDLE_SAW, HANDLE_SCREWDRIVER, HANDLE_BUZZSAW, HANDLE_ELECTRIC_SCREWDRIVER
		, POWER_UNIT_LV, POWER_UNIT_MV, POWER_UNIT_HV
		, DURABILITY_BAR_0, DURABILITY_BAR_1, DURABILITY_BAR_2, DURABILITY_BAR_3, DURABILITY_BAR_4, DURABILITY_BAR_5, DURABILITY_BAR_6, DURABILITY_BAR_7, DURABILITY_BAR_8
		, ENERGY_BAR_0, ENERGY_BAR_1, ENERGY_BAR_2, ENERGY_BAR_3, ENERGY_BAR_4, ENERGY_BAR_5, ENERGY_BAR_6, ENERGY_BAR_7, ENERGY_BAR_8
		;
		
		public static final IIconContainer[]
		DURABILITY_BAR = new IIconContainer[] {
			DURABILITY_BAR_0,
			DURABILITY_BAR_1,
			DURABILITY_BAR_2,
		    DURABILITY_BAR_3,
		    DURABILITY_BAR_4,
		    DURABILITY_BAR_5,
		    DURABILITY_BAR_6,
		    DURABILITY_BAR_7,
		    DURABILITY_BAR_8,
		},
		ENERGY_BAR = new IIconContainer[] {
			ENERGY_BAR_0,
			ENERGY_BAR_1,
			ENERGY_BAR_2,
			ENERGY_BAR_3,
			ENERGY_BAR_4,
			ENERGY_BAR_5,
			ENERGY_BAR_6,
			ENERGY_BAR_7,
			ENERGY_BAR_8,
		};
		
		public static final ITexture[] ERROR_RENDERING = new ITexture[] {new BlockTextureDefault(RENDERING_ERROR)};
		
		protected IIcon mIcon, mOverlay;
		
		@Override public IIcon getIcon(int aRenderPass) {return aRenderPass==1?mOverlay:mIcon;}
		
		private ItemIcons() {
			GT_API.sItemIconload.add(this);
		}
		
		@Override
		public ResourceLocation getTextureFile() {
			return TextureMap.locationItemsTexture;
		}
		
		@Override
		public void run() {
			mIcon		= GT_API.sItemIcons.registerIcon(RES_PATH_ITEM + "iconsets/" + this);
			mOverlay	= GT_API.sItemIcons.registerIcon(RES_PATH_ITEM + "iconsets/" + this + "_OVERLAY");
		}
		
		public static class CustomIcon implements IIconContainer, Runnable {
			protected IIcon mIcon, mOverlay;
			protected String mIconName;
			
			@Override public IIcon getIcon(int aRenderPass) {return aRenderPass==1?mOverlay:mIcon;}
			
			public CustomIcon(String aIconName) {
				mIconName = aIconName;
				GT_API.sItemIconload.add(this);
			}
			
			@Override
			public void run() {
				mIcon		= GT_API.sItemIcons.registerIcon(RES_PATH_ITEM + mIconName);
				mOverlay	= GT_API.sItemIcons.registerIcon(RES_PATH_ITEM + mIconName + "_OVERLAY");
			}
			
			@Override
			public ResourceLocation getTextureFile() {
				return TextureMap.locationItemsTexture;
			}
			@Override
			public short[] getIconColor(int aRenderPass) {
				return UNCOLOURED;
			}
			@Override
			public int getIconPasses() {
				return 2;
			}
			@Override
			public void registerIcons(IIconRegister aIconRegister) {
				//
			}

			@Override
			public boolean isUsingColorModulation(int aRenderPass) {
				// TODO Auto-generated method stub
				return aRenderPass == 0;
			}
		}
		
		@Override
		public short[] getIconColor(int aRenderPass) {
			return UNCOLOURED;
		}
		@Override
		public int getIconPasses() {
			return 2;
		}
		@Override
		public void registerIcons(IIconRegister aIconRegister) {
			//
		}

		@Override
		public boolean isUsingColorModulation(int aRenderPass) {
			// TODO Auto-generated method stub
			return aRenderPass == 0;
		}
	}
}